BarProfiler = LibStub("AceAddon-3.0"):NewAddon("BarProfiler", "AceConsole-3.0")
BarProfilerIcon = LibStub("LibDBIcon-1.0")
BarProfilerGui = LibStub("AceGUI-3.0")
BarProfiler:RegisterChatCommand("barprofiler", "BarProfilerSlash")
BarProfiler:RegisterChatCommand("bp", "BarProfilerSlash")
function BarProfiler:OnInitialize()
	local Key, Value
	BarProfilerDebug = 0	--needs moving into Db
	local Slot = 1
	if BarProfilerDb == nil then
		BarProfilerDb = {
			Version = 0.1,
			Realms = {},
			RealmList = {},
		}
		BarProfiler:Print ("Creating and initialising database to 0.1")
	end
	if BarProfilerDb.Version == 0.1 then
		BarProfilerDb.Version = 0.2
		BarProfilerDb.Minimap = {
			minimapPos = 243.5,
			Hide = false,
			Info = {}
		}
		BarProfiler:Print ("Upgrading database to 0.2")
	end
	if BarProfilerDb.Version == 0.2 then
		BarProfilerDb.Version = "0.2.1"
		BarProfilerDb.GUI = {
			Main = {
				point = "CENTER",
				relativeTo = nil,
				relativePoint = "CENTER",
				xOfs = 0,
				yOfs = 0
			},
			ConfirmationWindow = {
				point = "CENTER",
				relativeTo = nil,
				relativePoint = "CENTER",
				xOfs = 0,
				yOfs = 0
			}
		}
		BarProfiler:Print ("Upgrading database to 0.2.1")
	end
	if BarProfilerDb.Version == "0.2.1" then
		BarProfilerDb.Version = "0.2.3"
		BarProfilerDb.Adv = {
			Viewer = {}
		}
		BarProfilerDb.GUI.HideWarnings = false
		BarProfiler:Print ("Upgrading database to 0.2.3")
	end
	BarProfilerDb.CurrentRealm = GetRealmName()
	BarProfilerDb.CurrentCharacter = GetUnitName("player", True)
	if BarProfilerDb.Realms[BarProfilerDb.CurrentRealm] == nil then
		BarProfilerNewRealm()
		BarProfilerNewCharacter()
	else
		if BarProfilerDb.Realms[BarProfilerDb.CurrentRealm].Characters[BarProfilerDb.CurrentCharacter] == nil then
			BarProfilerNewCharacter()
		end
	end
	BarProfilerSlashCount = 0	--needs moving into Db
	tinsert(UISpecialFrames,"BarProfilerMainFrame")
	tinsert(UISpecialFrames,"BarProfilerMessageFrame")
	BarProfilerDb.Minimap.Info = LibStub("LibDataBroker-1.1"):NewDataObject("BarProfilerIconLabel", {	--only needs doing once?
		type = "data source",
		text = "BarProfilerIconLabel",
		icon = "Interface\\Icons\\Achievement_guildperk_workingovertime",
		OnClick = function() BarProfiler:BarProfilerSlash(nil) end,
		OnTooltipShow = function(tooltip)
		tooltip:AddLine("Bar Profiler")
		end,
	})
	BarProfilerIcon:Register("BarProfilerIconLabel", BarProfilerDb.Minimap.Info, BarProfilerDb.Minimap)
	--defaults
	BarProfilerDb.Adv.SelectedRealm = BarProfilerDb.CurrentRealm
	BarProfilerDb.Adv.SelectedCharacter = BarProfilerDb.CurrentCharacter
	BarProfilerDb.Adv.SelectedProfile = nil
	BarProfilerDb.SelectedProfile = nil
	for Key,Value in pairs(BarProfilerDb.RealmList) do
		if Value == BarProfilerDb.Adv.SelectedRealm then
			BarProfilerDb.Adv.SelectedRealmKey = Key
			break 
		end
	end
	for Key, Value in pairs(BarProfilerDb.Realms[BarProfilerDb.Adv.SelectedRealm].CharacterList) do
		if Value == BarProfilerDb.Adv.SelectedCharacter then
			BarProfilerDb.Adv.SelectedCharacterKey = Key
			break
		end
	end
	BarProfilerDb.Adv.SelectedProfileKey = nil	--this wants doing properly
	BarProfilerDb.GUI.Inhibit = nil
	BarProfiler:Print ("Loaded")
end
local BarProfilerFrame = CreateFrame("Frame")
	BarProfilerFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
	local function eventHandler()
		BarProfilerMinimapToggleHandler (BarProfilerDb.Minimap.Hide)
		local temp = BarProfilerDb.Realms[BarProfilerDb.CurrentRealm].Characters[BarProfilerDb.CurrentCharacter].Version
		if temp == nil or temp == "0.1" then
			BarProfilerCharUpdate()
		end
--		if BarProfilerDb.DisableFilter == true then
--			SetCVar("profanityFilter", 0)
--		end
	end
local BarProfilerExit = CreateFrame("Frame")
	BarProfilerExit:RegisterEvent("PLAYER_LOGOUT")
	local function eventHandler2()
		BarProfilerDb.Adv.Viewer = {}
	end
BarProfilerFrame:SetScript("OnEvent", eventHandler)
BarProfilerExit:SetScript("OnEvent", eventHandler2)

function BarProfilerCharUpdate()
	BarProfilerDb.Realms[BarProfilerDb.CurrentRealm].Characters[BarProfilerDb.CurrentCharacter].Backups = {
		Update1 = {}
	}
	for CreateSlotsLoop = 1, 120 do
		BarProfilerDb.Realms[BarProfilerDb.CurrentRealm].Characters[BarProfilerDb.CurrentCharacter].Backups.Update1[CreateSlotsLoop] = {}
	end
	BarProfilerSaveBars("Backups", "Update1")
	for Key,Value in pairs(BarProfilerDb.Realms[BarProfilerDb.CurrentRealm].Characters[BarProfilerDb.CurrentCharacter].ProfileList) do
		BarProfilerLoadBars("Profiles", Value, true)
		BarProfilerSaveBars("Profiles", Value, true)
		BarProfilerNameCheck(Key, Value)
	end
	BarProfilerLoadBars("Backups", "Update1", true)
	BarProfilerDb.Realms[BarProfilerDb.CurrentRealm].Characters[BarProfilerDb.CurrentCharacter].Version = "0.1.1"
	BarProfiler:Print ("Character Database updated to v0.1.1")
end

function BarProfilerNewRealm()
	BarProfilerDb.Realms[BarProfilerDb.CurrentRealm] =	{
		CharacterList = {},
		Characters = {}
	}
	table.insert (BarProfilerDb.RealmList, BarProfilerDb.CurrentRealm)
end
function BarProfilerNewCharacter()
	BarProfilerDb.Realms[BarProfilerDb.CurrentRealm].Characters[BarProfilerDb.CurrentCharacter] = 	{
		ProfileList = {},
		Profiles = {},
		Version = "0.1.1"
	}
	BarProfilerDb.Realms[BarProfilerDb.CurrentRealm].Characters[BarProfilerDb.CurrentCharacter].Class = UnitClass("player")
	table.insert (BarProfilerDb.Realms[BarProfilerDb.CurrentRealm].CharacterList, BarProfilerDb.CurrentCharacter)
end
function BarProfiler:BarProfilerSlash(input)
	local Command, Argument
	if input ~= nil then
		Command, Argument = input:match("^(%S*)%s*(.-)$")
	end
	if Command == "resetgui" then
		BarProfilerDb.GUI = {
			Main = {
				point = "CENTER",
				relativeTo = nil,
				relativePoint = "CENTER",
				xOfs = 0,
				yOfs = 0
			},
			ConfirmationWindow = {
				point = "CENTER",
				relativeTo = nil,
				relativePoint = "CENTER",
				xOfs = 0,
				yOfs = 0
			}
		}
		BarProfiler:Print ("Position of GUI reset to center")
	elseif Command == "load" then
		print ("load")
		if BarProfilerDb.Realms[BarProfilerDb.CurrentRealm].Characters[BarProfilerDb.CurrentCharacter].Profiles[Argument] == nil then
			BarProfiler:Print("Error - Profile " .. Argument .. " not found")
		else
			BarProfilerLoadBars("Profiles", Argument)
		end
	elseif Command == "forcecharupdate" then
		BarProfilerCharUpdate()
	elseif BarProfilerDb.GUI.Inhibit == nil then
		if BarProfilerSlashCount == 0 then
			BarProfilerSlashCount = 1
			BarProfilerGuiMain()
		else
			BarProfilerSlashCount = 0
			BarProfilerGuiMainCloseHandler()
		end
	end
end
function BarProfilerDebugPrint(Str)
	if BarProfilerDebug == 1 then
		BarProfiler:Print ("DEBUG:",Str)
	end
end
function BarProfilerNameCheck (Key, ProfileName)	
	local test, test1 = string.find(ProfileName, "%a")
	if test ~= 1 or test1 ~= 1 then
		NewName = "[Error]:" .. ProfileName
		BarProfiler:Print ("Invalid Profile name found! Renaming it to:")
		print (NewName)
		BarProfilerDb.SelectedProfile = Key
		BarProfilerRenameProfile(NewName, true)
	end
end