function BarProfilerGuiAdvancedTab ()	
	BarProfilerTabGroup:SetLayout("Flow")
	BarProfilerGuiAdvancedTabRealms = BarProfilerGui:Create("Dropdown")
		BarProfilerGuiAdvancedTabRealms:SetLabel("Realm:")
		BarProfilerGuiAdvancedTabRealms:SetList(BarProfilerDb.RealmList)
		BarProfilerGuiAdvancedTabRealms:SetValue(BarProfilerDb.Adv.SelectedRealmKey)
		BarProfilerGuiAdvancedTabRealms:SetCallback("OnValueChanged", function(widget, event, key) BarProfilerGuiAdvancedTabRealmsHandler(key) end)
		BarProfilerTabGroup:AddChild(BarProfilerGuiAdvancedTabRealms)
		
	BarProfilerGuiAdvancedTabCharacters = BarProfilerGui:Create("Dropdown")
		BarProfilerGuiAdvancedTabCharacters:SetLabel("Character:")
		BarProfilerGuiAdvancedTabCharacters:SetList(BarProfilerDb.Realms[BarProfilerDb.Adv.SelectedRealm].CharacterList)
		BarProfilerGuiAdvancedTabDisableProfiles()
		BarProfilerGuiAdvancedTabCharacters:SetValue(BarProfilerDb.Adv.SelectedCharacterKey)
		BarProfilerGuiAdvancedTabCharacters:SetCallback("OnValueChanged", function(widget, event, key) BarProfilerGuiAdvancedTabCharactersHandler(key) end)
		BarProfilerTabGroup:AddChild(BarProfilerGuiAdvancedTabCharacters)
		
	BarProfilerGuiAdvancedTabProfile = BarProfilerGui:Create("Dropdown")
		BarProfilerGuiAdvancedTabProfile:SetLabel("Profile:")
		if BarProfilerDb.Adv.SelectedCharacter == nil then
			BarProfilerGuiAdvancedTabProfile:SetDisabled(1)
		else
			if not next(BarProfilerDb.Realms[BarProfilerDb.Adv.SelectedRealm].Characters[BarProfilerDb.Adv.SelectedCharacter].ProfileList) then
				BarProfilerGuiAdvancedTabProfile:SetDisabled(1)
			end
			BarProfilerGuiAdvancedTabProfile:SetList(BarProfilerDb.Realms[BarProfilerDb.Adv.SelectedRealm].Characters[BarProfilerDb.Adv.SelectedCharacter].ProfileList)
		end
		BarProfilerGuiAdvancedTabProfile:SetCallback("OnValueChanged", function(widget, event, key) BarProfilerGuiAdvancedTabProfileHandler(key) end)
		BarProfilerTabGroup:AddChild(BarProfilerGuiAdvancedTabProfile)
		
	BarProfilerGuiAdvancedTabIgnoreAll = BarProfilerGui:Create("Button")	
		BarProfilerGuiAdvancedTabIgnoreAll:SetText("Ignore All")
		BarProfilerGuiAdvancedTabIgnoreAll:SetCallback("OnClick", 	function(widget) BarProfilerGuiAdvancedTabIgnoreAllOnClick() end)
		BarProfilerTabGroup:AddChild(BarProfilerGuiAdvancedTabIgnoreAll)
	
	BarProfilerGuiAdvancedTabIgnoreNone = BarProfilerGui:Create("Button")	
		BarProfilerGuiAdvancedTabIgnoreNone:SetText("Ignore None")
		BarProfilerGuiAdvancedTabIgnoreNone:SetCallback("OnClick", 	function(widget) BarProfilerGuiAdvancedTabIgnoreNoneOnClick() end)
		BarProfilerTabGroup:AddChild(BarProfilerGuiAdvancedTabIgnoreNone)
		--wants to be in a function itself
		if BarProfilerDb.CurrentCharacter ~= BarProfilerDb.Adv.SelectedCharacter or BarProfilerDb.Adv.SelectedProfile == nil then	
			BarProfilerGuiAdvancedTabIgnoreAll:SetDisabled(1)
			BarProfilerGuiAdvancedTabIgnoreNone:SetDisabled(1)
		else
			BarProfilerGuiAdvancedTabIgnoreAll:SetDisabled(nil)
			BarProfilerGuiAdvancedTabIgnoreNone:SetDisabled(nil)
		end
		
	BarProfilerGuiAdvancedTabImport = BarProfilerGui:Create("EditBox")
		BarProfilerGuiAdvancedTabImport:SetLabel("Copy Profile")
		BarProfilerGuiAdvancedTabImport:SetCallback("OnEnterPressed", function(widget, event, key) BarProfilerGuiAdvancedTabImportHandler(widget, event, key) end)
		BarProfilerGuiAdvancedTabImport:SetDisabled(1)
		BarProfilerTabGroup:AddChild(BarProfilerGuiAdvancedTabImport)
	
	BarProfilerGuiAdvancedTabPreview = BarProfilerGui:Create("InlineGroup")
		BarProfilerGuiAdvancedTabPreview:SetFullHeight(true)
		BarProfilerGuiAdvancedTabPreview:SetFullWidth(true)
		BarProfilerGuiAdvancedTabPreview:SetLayout("Fill")
		BarProfilerTabGroup:AddChild(BarProfilerGuiAdvancedTabPreview)
		
	BarProfilerGuiAdvancedTabPreviewScroll = BarProfilerGui:Create("ScrollFrame")
		BarProfilerGuiAdvancedTabPreviewScroll:SetLayout("Flow")
		BarProfilerGuiAdvancedTabPreview:AddChild(BarProfilerGuiAdvancedTabPreviewScroll)
		
end

function BarProfilerGuiAdvancedTabImportHandler(widget, event, key)
	BarProfilerCreateProfile(key)	--look into getting rid of the restart in this! - yeah, yeah, done. (I think)
	Old = BarProfilerDb.Realms[BarProfilerDb.Adv.SelectedRealm].Characters[BarProfilerDb.Adv.SelectedCharacter].Profiles[BarProfilerDb.Adv.SelectedProfile]
	New = BarProfilerDb.Realms[BarProfilerDb.CurrentRealm].Characters[BarProfilerDb.CurrentCharacter].Profiles[key]
	str = ""
	for SlotLoop = 1, 120 do
		if Old[SlotLoop].Type ~= 'macro' and Old[SlotLoop].Type ~= 'equipmentset' and Old[SlotLoop].Type ~= 'companion' then
			New[SlotLoop] = Old[SlotLoop]
			New.DataCheck = 1
		else
			New.Texture = "Interface\\BUTTONS\\UI-EmptySlot-Disabled"
		end
	end
	BarProfiler:Print ("Profile Copy Successful")
end
function BarProfilerGuiAdvancedTabRealmsHandler(key)
	BarProfilerDb.Adv.SelectedRealmKey = key
	BarProfilerDb.Adv.SelectedRealm = BarProfilerDb.RealmList[key]
	BarProfilerDb.Adv.SelectedCharacter = nil
	BarProfilerDb.Adv.SelectedCharacterKey = nil
	BarProfilerDb.Adv.SelectedProfile = nil
	BarProfilerDb.Adv.SelectedProfileKey = nil
	BarProfilerGuiAdvancedTabProfile:SetDisabled(1)
	BarProfilerGuiAdvancedTabCharacters:SetList(BarProfilerDb.Realms[BarProfilerDb.Adv.SelectedRealm].CharacterList)
	BarProfilerGuiAdvancedTabCharacters:SetValue(0)
	BarProfilerDb.Adv.SelectedCharacter = nil
	BarProfilerGuiAdvancedTabDisableProfiles()
	BarProfilerGuiAdvancedTabIgnoreNone:SetDisabled(1)
end
function BarProfilerGuiAdvancedTabCharactersHandler(key)
	BarProfilerDb.Adv.SelectedCharacterKey = key
	BarProfilerDb.Adv.SelectedCharacter = BarProfilerDb.Realms[BarProfilerDb.Adv.SelectedRealm].CharacterList[key]
	BarProfilerDb.Adv.SelectedProfile = nil
	BarProfilerDb.Adv.SelectedProfileKey = nil
	if not next(BarProfilerDb.Realms[BarProfilerDb.Adv.SelectedRealm].Characters[BarProfilerDb.Adv.SelectedCharacter].ProfileList) then
		BarProfilerGuiAdvancedTabProfile:SetDisabled(1)
	else
		BarProfilerGuiAdvancedTabProfile:SetDisabled(nil)
	end
	if BarProfilerDb.CurrentCharacter ~= BarProfilerDb.Adv.SelectedCharacter then
		BarProfilerGuiAdvancedTabIgnoreNone:SetDisabled(1)
	else
		BarProfilerGuiAdvancedTabIgnoreNone:SetDisabled(nil)
	end
	BarProfilerGuiAdvancedTabProfile:SetList(BarProfilerDb.Realms[BarProfilerDb.Adv.SelectedRealm].Characters[BarProfilerDb.Adv.SelectedCharacter].ProfileList)
	BarProfilerGuiAdvancedTabProfile:SetValue(0)
	BarProfilerGuiAdvancedTabIgnoreNone:SetDisabled(1)
	BarProfilerGuiAdvancedTabIgnoreAll:SetDisabled(1)
end
function BarProfilerGuiAdvancedTabDisableProfiles()
	for Key, Value in pairs(BarProfilerDb.Realms[BarProfilerDb.Adv.SelectedRealm].CharacterList) do
	if BarProfilerDb.Realms[BarProfilerDb.Adv.SelectedRealm].Characters[Value].Version == nil then
		BarProfilerGuiAdvancedTabCharacters:SetItemDisabled(Key, true)
		end
	end
end
function BarProfilerGuiAdvancedTabProfileHandler(key)
	local icon, name, rank, Backup, Temp
	if BarProfilerDb.CurrentCharacter ~= BarProfilerDb.Adv.SelectedCharacter then
		BarProfilerGuiAdvancedTabIgnoreAll:SetDisabled(1)
		BarProfilerGuiAdvancedTabIgnoreNone:SetDisabled(1)
	else
		BarProfilerGuiAdvancedTabIgnoreAll:SetDisabled(nil)
		BarProfilerGuiAdvancedTabIgnoreNone:SetDisabled(nil)
	end
	if BarProfilerDb.Realms[BarProfilerDb.Adv.SelectedRealm].Characters[BarProfilerDb.Adv.SelectedCharacter].Class == BarProfilerDb.Realms[BarProfilerDb.CurrentRealm].Characters[BarProfilerDb.CurrentCharacter].Class then
		BarProfilerGuiAdvancedTabImport:SetDisabled(nil)
	else
		BarProfilerGuiAdvancedTabImport:SetDisabled(1)
	end
	backup = 0
	BarProfilerGuiAdvancedTabPreviewScroll:ReleaseChildren()
	BarProfilerDb.Adv.SelectedProfile = BarProfilerDb.Realms[BarProfilerDb.Adv.SelectedRealm].Characters[BarProfilerDb.Adv.SelectedCharacter].ProfileList[key]
	for SlotLoop = 1, 120 do
		Temp = ((SlotLoop - 1) / 12) + 1
		Temp = math.modf(Temp)
		if Temp ~= Backup then
			BarProfilerDbBarLabel = BarProfilerGui:Create("Label")
				BarProfilerDbBarLabel:SetText(Temp)
				BarProfilerDbBarLabel:SetWidth(20)
				BarProfilerDbBarLabel:SetFont ("Fonts\\FRIZQT__.TTF", 15)
				BarProfilerGuiAdvancedTabPreviewScroll:AddChild(BarProfilerDbBarLabel)
		end
		Backup = Temp
		BarProfilerDb.Adv.Viewer[SlotLoop] = BarProfilerGui:Create("Icon")
			BarProfilerDb.Adv.Viewer[SlotLoop]:SetHeight(50)
			BarProfilerDb.Adv.Viewer[SlotLoop]:SetWidth(50)
			BarProfilerDb.Adv.Viewer[SlotLoop]:SetImageSize(50, 50)
			BarProfilerDb.Adv.Viewer[SlotLoop]:SetImage(BarProfilerDb.Realms[BarProfilerDb.Adv.SelectedRealm].Characters[BarProfilerDb.Adv.SelectedCharacter].Profiles[BarProfilerDb.Adv.SelectedProfile][SlotLoop].Texture)
			--todo: unnecasary variables being sent
			BarProfilerDb.Adv.Viewer[SlotLoop]:SetCallback("OnEnter", function(Widget, Event, Key) BarProfilerGuiAdvOnEnter(Widget, Event, Key) end)
			BarProfilerDb.Adv.Viewer[SlotLoop]:SetCallback("OnLeave", function(Widget, Event, Key) BarProfilerGuiAdvOnLeave(Widget, Event, Key) end)
			BarProfilerDb.Adv.Viewer[SlotLoop]:SetCallback("OnClick", function(Widget, Event, Key) BarProfilerGuiAdvOnClick(Widget, Event, Key) end)
			if BarProfilerDb.Realms[BarProfilerDb.Adv.SelectedRealm].Characters[BarProfilerDb.Adv.SelectedCharacter].Profiles[BarProfilerDb.Adv.SelectedProfile][SlotLoop].Ignore == true then
				BarProfilerDb.Adv.Viewer[SlotLoop].image:SetVertexColor(0.2, 0.2, 0.2)
			end
			BarProfilerGuiAdvancedTabPreviewScroll:AddChild(BarProfilerDb.Adv.Viewer[SlotLoop])
	end
end
function BarProfilerGuiAdvOnClick(Widget, Event, Key2)
	local Key, Value, Type, GlobalID, SubType, Name, BType, BGlobalID, BSubType, BName
	Key = BarProfilerAdvFindKey(Widget)
	if BarProfilerDb.CurrentCharacter == BarProfilerDb.Adv.SelectedCharacter then
		if GetCursorInfo() == nil then
			BarProfilerAdvIgnoreToggle(Key)
		else
		me = BarProfilerDb.Realms[BarProfilerDb.Adv.SelectedRealm].Characters[BarProfilerDb.Adv.SelectedCharacter].Profiles[BarProfilerDb.Adv.SelectedProfile][Key]
		--Backup existing data from barprofiler slot
		Type = me.Type
		GlobalID = me.GlobalID
		SubType = me.SubType
		Texture = me.Texture
		Name = me.Name
		--Backup action in slot 1
		BType, BGlobalID, BSubType, BTexture, BName = BarProfilerGetAction(1)	--Bname probabnly not wanted
		--Place new action in slot 1
		PlaceAction(1)
		--Save new action in slot 1
		me.Type, me.GlobalID, me.SubType, me.Texture, me.Name = BarProfilerGetAction(1)
		BarProfilerDb.Adv.Viewer[Key]:SetImage(me.Texture)
		ClearCursor()
		--Get old action that was orig in slot 1
		BarProfilerPickUpAction(1, BType, BGlobalID, BSubType, BName)
		--place action in slot 1
		BarProfilerPlaceAction(1)
		--pickup existing action from barprofiler slot
		BarProfilerPickUpAction(1, Type, GlobalID, SubType, Name)
		end
	end
end
function BarProfilerGuiAdvOnEnter(Widget, Event, Key)
	local Key
	Key = BarProfilerAdvFindKey(Widget)	
	if BarProfilerDb.Adv.SelectedProfile ~= nil then
		me =  BarProfilerDb.Realms[BarProfilerDb.Adv.SelectedRealm].Characters[BarProfilerDb.Adv.SelectedCharacter].Profiles[BarProfilerDb.Adv.SelectedProfile][Key]
		GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR")
		if me.Type == "spell" then
			GameTooltip:SetSpellByID(me.GlobalID)
		elseif me.Type == "item" then
			GameTooltip:SetItemByID(me.GlobalID)
		elseif me.Type == "macro" then
			GameTooltip:AddLine(me.Name, 1, 1, 1)
			GameTooltip:AddLine("Macro")
		elseif me.Type == "equipmentset" then
			GameTooltip:AddLine(me.GlobalID, 1, 1, 1)
			GameTooltip:AddLine("Equipment Set")
		elseif me.Type == "companion" then
			GameTooltip:AddLine(me.Name, 1, 1, 1)
			if me.SubType == "CRITTER" then
				GameTooltip:AddLine("Pet")
			elseif me.SubType == "MOUNT" then
				GameTooltip:AddLine("Mount")
			end
		end
		GameTooltip:Show()
	end
end
function BarProfilerGuiAdvOnLeave(Widget, Event, Key)
	if BarProfilerDb.CurrentCharacter == BarProfilerDb.Adv.SelectedCharacter then --todo: some form of message sayign it MUST be the right mouse button
		Key = BarProfilerAdvFindKey(Widget)
		if IsMouseButtonDown(2) == 1 and GetCursorInfo() == nil then	--mousebutton can be handled with key?
			me = BarProfilerDb.Realms[BarProfilerDb.Adv.SelectedRealm].Characters[BarProfilerDb.Adv.SelectedCharacter].Profiles[BarProfilerDb.Adv.SelectedProfile][Key]
			BarProfilerPickUpAction(Key, me.Type, me.GlobalID, me.SubType, me.Name)
			me.GlobalID = nil
			me.Type = nil
			me.SubType = nil
			me.Texture = "Interface\\BUTTONS\\UI-EmptySlot-Disabled"
			me.Name = nil
			BarProfilerDb.Adv.Viewer[Key]:SetImage("Interface\\BUTTONS\\UI-EmptySlot-Disabled")
		end
		if IsMouseButtonDown(1) == 1 and GetCursorInfo() == nil then
			BarProfilerAdvIgnoreToggle(Key)
		end
	end
	GameTooltip:Hide()
end
function BarProfilerAdvFindKey(Widget)
	for Key, Value in pairs(BarProfilerDb.Adv.Viewer) do
		if Value == Widget then
			return Key
		end
	end
end
function BarProfilerAdvIgnoreToggle(Key, Ignore)
	if Ignore == nil then
		if BarProfilerDb.Realms[BarProfilerDb.Adv.SelectedRealm].Characters[BarProfilerDb.Adv.SelectedCharacter].Profiles[BarProfilerDb.Adv.SelectedProfile][Key].Ignore == true then
			BarProfilerDb.Realms[BarProfilerDb.Adv.SelectedRealm].Characters[BarProfilerDb.Adv.SelectedCharacter].Profiles[BarProfilerDb.Adv.SelectedProfile][Key].Ignore = nil
			BarProfilerDb.Adv.Viewer[Key].image:SetVertexColor(1, 1, 1)
		else
			BarProfilerDb.Realms[BarProfilerDb.Adv.SelectedRealm].Characters[BarProfilerDb.Adv.SelectedCharacter].Profiles[BarProfilerDb.Adv.SelectedProfile][Key].Ignore = true
			BarProfilerDb.Adv.Viewer[Key].image:SetVertexColor(0.2, 0.2, 0.2)
		end
	elseif Ignore == true then
		BarProfilerDb.Realms[BarProfilerDb.Adv.SelectedRealm].Characters[BarProfilerDb.Adv.SelectedCharacter].Profiles[BarProfilerDb.Adv.SelectedProfile][Key].Ignore = true
		BarProfilerDb.Adv.Viewer[Key].image:SetVertexColor(0.2, 0.2, 0.2)
	elseif Ignore == false then
		BarProfilerDb.Realms[BarProfilerDb.Adv.SelectedRealm].Characters[BarProfilerDb.Adv.SelectedCharacter].Profiles[BarProfilerDb.Adv.SelectedProfile][Key].Ignore = nil
		BarProfilerDb.Adv.Viewer[Key].image:SetVertexColor(1, 1, 1)
	end 
end
--Can be combined into 1 function
function BarProfilerGuiAdvancedTabIgnoreAllOnClick()
	local SlotLoop
	for SlotLoop = 1, 120 do
		BarProfilerAdvIgnoreToggle(SlotLoop, true)
	end
end
function BarProfilerGuiAdvancedTabIgnoreNoneOnClick()
	local SlotLoop
	for SlotLoop = 1, 120 do
		BarProfilerAdvIgnoreToggle(SlotLoop, false)
	end
end
