function BarProfilerGuiMain()
	BarProfilerMainFrame = BarProfilerGui:Create("Frame")
		BarProfilerMainFrame:SetTitle("Bar Profiler")
		BarProfilerMainFrame:EnableResize(Hide)
		BarProfilerMainFrame:SetWidth(720)
		BarProfilerMainFrame:SetHeight(400)
		BarProfilerMainFrame:SetCallback("OnClose",	function(widget, event, profilename) BarProfilerGuiMainCloseHandler(widget) end)
		BarProfilerMainFrame:SetLayout("Fill")
		BarProfilerMainFrame:SetPoint(BarProfilerDb.GUI.Main.point, BarProfilerDb.GUI.Main.relativeTo, BarProfilerDb.GUI.Main.relativePoint, BarProfilerDb.GUI.Main.xOfs, BarProfilerDb.GUI.Main.yOfs)
		if BarProfilerDb.Realms[BarProfilerDb.CurrentRealm].Characters[BarProfilerDb.CurrentCharacter].LoadedProfile ~= nil then
			BarProfilerMainFrame:SetStatusText("Last Profile Loaded: " .. BarProfilerDb.Realms[BarProfilerDb.CurrentRealm].Characters[BarProfilerDb.CurrentCharacter].LoadedProfile)
		end
		BarProfilerMainFrame.statustext:SetTextColor(1, 1, 1)
		
	BarProfilerTabGroup =  BarProfilerGui:Create("TabGroup")
		BarProfilerTabGroup:SetLayout("Flow")
		BarProfilerTabGroup:SetTabs({{text="Main", value="Main"}, {text="Advanced", value="Advanced"}, {text="Settings", value="Settings"}})
		BarProfilerTabGroup:SetCallback("OnGroupSelected", BarProfilerGuiSelectTab)
		BarProfilerTabGroup:SelectTab("Main")	--save current tab?
		BarProfilerMainFrame:AddChild(BarProfilerTabGroup)
end

function BarProfilerGuiSelectTab(container, event, group)
	container:ReleaseChildren()	--annoying
	if group == "Main" then
		BarProfilerGuiMainTab()
	elseif group == "Advanced" then
		BarProfilerGuiAdvancedTab ()
	elseif group == "Settings" then
		BarProfilerGuiSettingsTab()
	end
end
function BarProfilerGuiMainCloseHandler()
	local point, relativeTo, relativePoint, xOfs, yOfs = BarProfilerMainFrame:GetPoint()
	if relativeTo == nil then
		BarProfilerDb.GUI.Main = {
			point = point,
			relativeTo = relativeTo,
			relativePoint = relativePoint,
			xOfs = xOfs,
			yOfs = yOfs
		}
	end
	BarProfilerGui:Release(BarProfilerMainFrame)
	BarProfilerSlashCount = 0
end