function BarProfilerGuiMainTab()	
	BarProfilerProfileList = BarProfilerGui:Create("InlineGroup")
		BarProfilerProfileList:SetWidth(230)
		BarProfilerProfileList:SetLayout("List")
		BarProfilerProfileList:SetAutoAdjustHeight(false)
		BarProfilerProfileList:SetHeight(280)
		BarProfilerTabGroup:AddChild(BarProfilerProfileList)
		
	BarProfilerNewProfileEditBox = BarProfilerGui:Create("EditBox")
		BarProfilerNewProfileEditBox:SetLabel("Enter a name to create a new Profile:")
		BarProfilerNewProfileEditBox:SetCallback("OnEnterPressed", 	function(widget, event, ProfileName) BarProfilerNewProfileEditBoxHandler(ProfileName) end)
		BarProfilerProfileList:AddChild(BarProfilerNewProfileEditBox)
		
	BarProfilerProfileList2 = BarProfilerGui:Create("InlineGroup")
		BarProfilerProfileList2:SetWidth(210)
		BarProfilerProfileList2:SetHeight(200)
		BarProfilerProfileList2:SetAutoAdjustHeight(false)
		BarProfilerProfileList2:SetLayout("Fill")
		BarProfilerProfileList:AddChild(BarProfilerProfileList2)
		
	BarProfilerProfileListScroll = BarProfilerGui:Create("ScrollFrame")
	BarProfilerProfileListScroll:SetAutoAdjustHeight(false)
		BarProfilerProfileList2:AddChild(BarProfilerProfileListScroll)
		
		BarProfilerListOject = {}
		for Key, Value in pairs(BarProfilerDb.Realms[BarProfilerDb.CurrentRealm].Characters[BarProfilerDb.CurrentCharacter].ProfileList) do
			BarProfilerListOject[Key] = BarProfilerGui:Create("InteractiveLabel")
				BarProfilerListOject[Key]:SetFont ("Fonts\\FRIZQT__.TTF", 12)
				BarProfilerListOject[Key]:SetText(Value)
				BarProfilerListOject[Key]:SetCallback("OnClick", function(widget, event, key) BarProfilerDb.SelectedProfile=BarProfilerListOjectHandler(widget, event, key) end)
				BarProfilerProfileListScroll:AddChild(BarProfilerListOject[Key])
		end	
		
	BarProfilerMainGroup = BarProfilerGui:Create("InlineGroup")
		BarProfilerMainGroup:SetWidth(230)
		BarProfilerMainGroup:SetAutoAdjustHeight(false)
		BarProfilerMainGroup:SetHeight(280)
		BarProfilerTabGroup:AddChild(BarProfilerMainGroup)
	
	BarProfilerDeleteButton = BarProfilerGui:Create("Button")
		BarProfilerDeleteButton:SetText("Delete Profile")
		BarProfilerDeleteButton:SetCallback("OnClick", 	function(widget) BarProfilerDeleteButtonHandler() end)
		BarProfilerMainGroup:AddChild(BarProfilerDeleteButton)
		BarProfilerDeleteButton:SetDisabled(1)
		
	BarProfilerSaveButton = BarProfilerGui:Create("Button")
		BarProfilerSaveButton:SetText("Save Bars to Profile")
		BarProfilerSaveButton:SetCallback("OnClick", 	function(widget) BarProfilerSaveButtonHandler() end)
		BarProfilerMainGroup:AddChild(BarProfilerSaveButton)
		BarProfilerSaveButton:SetDisabled(1)
		
	BarProfilerLoadButton = BarProfilerGui:Create("Button")
		BarProfilerLoadButton:SetText("Load Bars from Profile")
		BarProfilerLoadButton:SetCallback("OnClick", 	function(widget) BarProfilerLoadButtonHandler() end)
		BarProfilerMainGroup:AddChild(BarProfilerLoadButton)	
		BarProfilerLoadButton:SetDisabled(1)
		
	BarProfilerRenameProfileEditBox = BarProfilerGui:Create("EditBox")
		BarProfilerRenameProfileEditBox:SetLabel("Enter a name to rename the profile")
		BarProfilerRenameProfileEditBox:SetCallback("OnEnterPressed", 	function(widget, event, NewProfileName) BarProfilerRenameProfileEditBoxHandler(NewProfileName) end)
		BarProfilerMainGroup:AddChild(BarProfilerRenameProfileEditBox)		
		BarProfilerRenameProfileEditBox:SetDisabled(1)
		
	if BarProfilerDb.SelectedProfile ~= nil then
		BarProfileListHandler()
		BarProfilerListOject[BarProfilerDb.SelectedProfile]:SetColor (1, 0, 0)
	end
end

function BarProfilerNewProfileEditBoxHandler(ProfileName)
	BarProfilerCreateProfile(ProfileName)
	BarProfilerGuiMainCloseHandler()
	BarProfiler:BarProfilerSlash(nil)
end

function BarProfilerListOjectHandler(widget, event, key)	--I don't like this
	for Key, Value in pairs(BarProfilerListOject) do
		if Value == widget then
			BarProfileListHandler()
			BarProfilerListOject[Key]:SetColor (1, 0, 0)
			if BarProfilerDb.SelectedProfile ~= nil then
				if Key ~= BarProfilerDb.SelectedProfile then
					BarProfilerListOject[BarProfilerDb.SelectedProfile]:SetColor (1, 1, 1)
				end
			end
			return Key
		end
	end
end

function BarProfilerDeleteButtonHandler()
	local str = "Caution: This profile and the action bars saved under it will be lost. Are you sure you wish to continue?"
	BarProfilerConfirmationWindow(str, "DeleteProfile")
end

function BarProfilerSaveButtonHandler()
	local str = "Caution: The current action bar data for this profile will be lost. Are you sure you wish to continue?"
	BarProfilerConfirmationWindow(str, "SaveBars")
end

function BarProfilerLoadButtonHandler()
	local str = "Caution: Loading a profile will re-arrange all of your current action bars. It is advised you save your current action bars before doing this. Are you sure you wish to continue?"
	BarProfilerConfirmationWindow(str, "LoadBars")
end

function BarProfilerRenameProfileEditBoxHandler(NewProfileName)
	BarProfilerRenameProfile(NewProfileName)
	BarProfilerGuiMainCloseHandler()
	BarProfiler:BarProfilerSlash()
end
function BarProfileListHandler()
	BarProfilerDeleteButton:SetDisabled(nil)
	BarProfilerLoadButton:SetDisabled(nil)
	BarProfilerSaveButton:SetDisabled(nil)
	BarProfilerRenameProfileEditBox:SetDisabled(nil)
end
function BarProfilerMainLockToggle(Value)	--Old, not needed
	local Key, Value = nil, nil
	BarProfilerNewProfileEditBox:SetDisabled(Value)
	for Key, Value in pairs(BarProfilerDb.Realms[BarProfilerDb.CurrentRealm].Characters[BarProfilerDb.CurrentCharacter].ProfileList) do
		BarProfilerListOject[Key]:SetDisabled(Value)
	end
	BarProfilerDeleteButton:SetDisabled(Value)
	BarProfilerLoadButton:SetDisabled(Value)
	BarProfilerSaveButton:SetDisabled(Value)
	BarProfilerRenameProfileEditBox:SetDisabled(Value)
end